diff -Nru a/arch/ppc/syslib/Makefile b/arch/ppc/syslib/Makefile
--- a/arch/ppc/syslib/Makefile	Thu Mar 11 16:54:04 2004
+++ b/arch/ppc/syslib/Makefile	Thu Mar 11 16:54:04 2004
@@ -72,3 +72,5 @@
 obj-$(CONFIG_SERIAL_TEXT_DEBUG)	+= gen550_dbg.o
 endif
 obj-$(CONFIG_BOOTX_TEXT)	+= btext.o
+obj-$(CONFIG_40x)		+= dcr.o
+obj-$(CONFIG_BOOKE)		+= dcr.o
diff -Nru a/arch/ppc/syslib/dcr.S b/arch/ppc/syslib/dcr.S
--- /dev/null	Wed Dec 31 16:00:00 1969
+++ b/arch/ppc/syslib/dcr.S	Thu Mar 11 16:54:04 2004
@@ -0,0 +1,2080 @@
+/*
+ * arch/ppc/syslib/dcr.S
+ *
+ * "Indirect" DCR access
+ *
+ * Copyright (c) 2004 Eugene Surovegin <ebs@ebshome.net>
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under  the terms of  the GNU General Public License as published by the
+ * Free Software Foundation;  either version 2 of the License, or (at your
+ * option) any later version.
+ */
+
+#include <asm/ppc_asm.h>
+#include <asm/processor.h>
+
+#define DCR_ACCESS_PROLOG(table) \
+	rlwinm  r3,r3,4,18,27;   \
+	lis     r5,table@h;      \
+	ori     r5,r5,table@l;   \
+	add     r3,r3,r5;        \
+	mtctr   r3;              \
+	bctr
+
+_GLOBAL(__mfdcr)
+	DCR_ACCESS_PROLOG(__mfdcr_table)
+
+_GLOBAL(__mtdcr)
+	DCR_ACCESS_PROLOG(__mtdcr_table)
+
+__mfdcr_table:
+	mfdcr  r3,0; blr
+__mtdcr_table:	
+	mtdcr  0,r4; blr
+	mfdcr  r3,1; blr
+	mtdcr  1,r4; blr
+	mfdcr  r3,2; blr
+	mtdcr  2,r4; blr
+	mfdcr  r3,3; blr
+	mtdcr  3,r4; blr
+	mfdcr  r3,4; blr
+	mtdcr  4,r4; blr
+	mfdcr  r3,5; blr
+	mtdcr  5,r4; blr
+	mfdcr  r3,6; blr
+	mtdcr  6,r4; blr
+	mfdcr  r3,7; blr
+	mtdcr  7,r4; blr
+	mfdcr  r3,8; blr
+	mtdcr  8,r4; blr
+	mfdcr  r3,9; blr
+	mtdcr  9,r4; blr
+	mfdcr  r3,10; blr
+	mtdcr  10,r4; blr
+	mfdcr  r3,11; blr
+	mtdcr  11,r4; blr
+	mfdcr  r3,12; blr
+	mtdcr  12,r4; blr
+	mfdcr  r3,13; blr
+	mtdcr  13,r4; blr
+	mfdcr  r3,14; blr
+	mtdcr  14,r4; blr
+	mfdcr  r3,15; blr
+	mtdcr  15,r4; blr
+	mfdcr  r3,16; blr
+	mtdcr  16,r4; blr
+	mfdcr  r3,17; blr
+	mtdcr  17,r4; blr
+	mfdcr  r3,18; blr
+	mtdcr  18,r4; blr
+	mfdcr  r3,19; blr
+	mtdcr  19,r4; blr
+	mfdcr  r3,20; blr
+	mtdcr  20,r4; blr
+	mfdcr  r3,21; blr
+	mtdcr  21,r4; blr
+	mfdcr  r3,22; blr
+	mtdcr  22,r4; blr
+	mfdcr  r3,23; blr
+	mtdcr  23,r4; blr
+	mfdcr  r3,24; blr
+	mtdcr  24,r4; blr
+	mfdcr  r3,25; blr
+	mtdcr  25,r4; blr
+	mfdcr  r3,26; blr
+	mtdcr  26,r4; blr
+	mfdcr  r3,27; blr
+	mtdcr  27,r4; blr
+	mfdcr  r3,28; blr
+	mtdcr  28,r4; blr
+	mfdcr  r3,29; blr
+	mtdcr  29,r4; blr
+	mfdcr  r3,30; blr
+	mtdcr  30,r4; blr
+	mfdcr  r3,31; blr
+	mtdcr  31,r4; blr
+	mfdcr  r3,32; blr
+	mtdcr  32,r4; blr
+	mfdcr  r3,33; blr
+	mtdcr  33,r4; blr
+	mfdcr  r3,34; blr
+	mtdcr  34,r4; blr
+	mfdcr  r3,35; blr
+	mtdcr  35,r4; blr
+	mfdcr  r3,36; blr
+	mtdcr  36,r4; blr
+	mfdcr  r3,37; blr
+	mtdcr  37,r4; blr
+	mfdcr  r3,38; blr
+	mtdcr  38,r4; blr
+	mfdcr  r3,39; blr
+	mtdcr  39,r4; blr
+	mfdcr  r3,40; blr
+	mtdcr  40,r4; blr
+	mfdcr  r3,41; blr
+	mtdcr  41,r4; blr
+	mfdcr  r3,42; blr
+	mtdcr  42,r4; blr
+	mfdcr  r3,43; blr
+	mtdcr  43,r4; blr
+	mfdcr  r3,44; blr
+	mtdcr  44,r4; blr
+	mfdcr  r3,45; blr
+	mtdcr  45,r4; blr
+	mfdcr  r3,46; blr
+	mtdcr  46,r4; blr
+	mfdcr  r3,47; blr
+	mtdcr  47,r4; blr
+	mfdcr  r3,48; blr
+	mtdcr  48,r4; blr
+	mfdcr  r3,49; blr
+	mtdcr  49,r4; blr
+	mfdcr  r3,50; blr
+	mtdcr  50,r4; blr
+	mfdcr  r3,51; blr
+	mtdcr  51,r4; blr
+	mfdcr  r3,52; blr
+	mtdcr  52,r4; blr
+	mfdcr  r3,53; blr
+	mtdcr  53,r4; blr
+	mfdcr  r3,54; blr
+	mtdcr  54,r4; blr
+	mfdcr  r3,55; blr
+	mtdcr  55,r4; blr
+	mfdcr  r3,56; blr
+	mtdcr  56,r4; blr
+	mfdcr  r3,57; blr
+	mtdcr  57,r4; blr
+	mfdcr  r3,58; blr
+	mtdcr  58,r4; blr
+	mfdcr  r3,59; blr
+	mtdcr  59,r4; blr
+	mfdcr  r3,60; blr
+	mtdcr  60,r4; blr
+	mfdcr  r3,61; blr
+	mtdcr  61,r4; blr
+	mfdcr  r3,62; blr
+	mtdcr  62,r4; blr
+	mfdcr  r3,63; blr
+	mtdcr  63,r4; blr
+	mfdcr  r3,64; blr
+	mtdcr  64,r4; blr
+	mfdcr  r3,65; blr
+	mtdcr  65,r4; blr
+	mfdcr  r3,66; blr
+	mtdcr  66,r4; blr
+	mfdcr  r3,67; blr
+	mtdcr  67,r4; blr
+	mfdcr  r3,68; blr
+	mtdcr  68,r4; blr
+	mfdcr  r3,69; blr
+	mtdcr  69,r4; blr
+	mfdcr  r3,70; blr
+	mtdcr  70,r4; blr
+	mfdcr  r3,71; blr
+	mtdcr  71,r4; blr
+	mfdcr  r3,72; blr
+	mtdcr  72,r4; blr
+	mfdcr  r3,73; blr
+	mtdcr  73,r4; blr
+	mfdcr  r3,74; blr
+	mtdcr  74,r4; blr
+	mfdcr  r3,75; blr
+	mtdcr  75,r4; blr
+	mfdcr  r3,76; blr
+	mtdcr  76,r4; blr
+	mfdcr  r3,77; blr
+	mtdcr  77,r4; blr
+	mfdcr  r3,78; blr
+	mtdcr  78,r4; blr
+	mfdcr  r3,79; blr
+	mtdcr  79,r4; blr
+	mfdcr  r3,80; blr
+	mtdcr  80,r4; blr
+	mfdcr  r3,81; blr
+	mtdcr  81,r4; blr
+	mfdcr  r3,82; blr
+	mtdcr  82,r4; blr
+	mfdcr  r3,83; blr
+	mtdcr  83,r4; blr
+	mfdcr  r3,84; blr
+	mtdcr  84,r4; blr
+	mfdcr  r3,85; blr
+	mtdcr  85,r4; blr
+	mfdcr  r3,86; blr
+	mtdcr  86,r4; blr
+	mfdcr  r3,87; blr
+	mtdcr  87,r4; blr
+	mfdcr  r3,88; blr
+	mtdcr  88,r4; blr
+	mfdcr  r3,89; blr
+	mtdcr  89,r4; blr
+	mfdcr  r3,90; blr
+	mtdcr  90,r4; blr
+	mfdcr  r3,91; blr
+	mtdcr  91,r4; blr
+	mfdcr  r3,92; blr
+	mtdcr  92,r4; blr
+	mfdcr  r3,93; blr
+	mtdcr  93,r4; blr
+	mfdcr  r3,94; blr
+	mtdcr  94,r4; blr
+	mfdcr  r3,95; blr
+	mtdcr  95,r4; blr
+	mfdcr  r3,96; blr
+	mtdcr  96,r4; blr
+	mfdcr  r3,97; blr
+	mtdcr  97,r4; blr
+	mfdcr  r3,98; blr
+	mtdcr  98,r4; blr
+	mfdcr  r3,99; blr
+	mtdcr  99,r4; blr
+	mfdcr  r3,100; blr
+	mtdcr  100,r4; blr
+	mfdcr  r3,101; blr
+	mtdcr  101,r4; blr
+	mfdcr  r3,102; blr
+	mtdcr  102,r4; blr
+	mfdcr  r3,103; blr
+	mtdcr  103,r4; blr
+	mfdcr  r3,104; blr
+	mtdcr  104,r4; blr
+	mfdcr  r3,105; blr
+	mtdcr  105,r4; blr
+	mfdcr  r3,106; blr
+	mtdcr  106,r4; blr
+	mfdcr  r3,107; blr
+	mtdcr  107,r4; blr
+	mfdcr  r3,108; blr
+	mtdcr  108,r4; blr
+	mfdcr  r3,109; blr
+	mtdcr  109,r4; blr
+	mfdcr  r3,110; blr
+	mtdcr  110,r4; blr
+	mfdcr  r3,111; blr
+	mtdcr  111,r4; blr
+	mfdcr  r3,112; blr
+	mtdcr  112,r4; blr
+	mfdcr  r3,113; blr
+	mtdcr  113,r4; blr
+	mfdcr  r3,114; blr
+	mtdcr  114,r4; blr
+	mfdcr  r3,115; blr
+	mtdcr  115,r4; blr
+	mfdcr  r3,116; blr
+	mtdcr  116,r4; blr
+	mfdcr  r3,117; blr
+	mtdcr  117,r4; blr
+	mfdcr  r3,118; blr
+	mtdcr  118,r4; blr
+	mfdcr  r3,119; blr
+	mtdcr  119,r4; blr
+	mfdcr  r3,120; blr
+	mtdcr  120,r4; blr
+	mfdcr  r3,121; blr
+	mtdcr  121,r4; blr
+	mfdcr  r3,122; blr
+	mtdcr  122,r4; blr
+	mfdcr  r3,123; blr
+	mtdcr  123,r4; blr
+	mfdcr  r3,124; blr
+	mtdcr  124,r4; blr
+	mfdcr  r3,125; blr
+	mtdcr  125,r4; blr
+	mfdcr  r3,126; blr
+	mtdcr  126,r4; blr
+	mfdcr  r3,127; blr
+	mtdcr  127,r4; blr
+	mfdcr  r3,128; blr
+	mtdcr  128,r4; blr
+	mfdcr  r3,129; blr
+	mtdcr  129,r4; blr
+	mfdcr  r3,130; blr
+	mtdcr  130,r4; blr
+	mfdcr  r3,131; blr
+	mtdcr  131,r4; blr
+	mfdcr  r3,132; blr
+	mtdcr  132,r4; blr
+	mfdcr  r3,133; blr
+	mtdcr  133,r4; blr
+	mfdcr  r3,134; blr
+	mtdcr  134,r4; blr
+	mfdcr  r3,135; blr
+	mtdcr  135,r4; blr
+	mfdcr  r3,136; blr
+	mtdcr  136,r4; blr
+	mfdcr  r3,137; blr
+	mtdcr  137,r4; blr
+	mfdcr  r3,138; blr
+	mtdcr  138,r4; blr
+	mfdcr  r3,139; blr
+	mtdcr  139,r4; blr
+	mfdcr  r3,140; blr
+	mtdcr  140,r4; blr
+	mfdcr  r3,141; blr
+	mtdcr  141,r4; blr
+	mfdcr  r3,142; blr
+	mtdcr  142,r4; blr
+	mfdcr  r3,143; blr
+	mtdcr  143,r4; blr
+	mfdcr  r3,144; blr
+	mtdcr  144,r4; blr
+	mfdcr  r3,145; blr
+	mtdcr  145,r4; blr
+	mfdcr  r3,146; blr
+	mtdcr  146,r4; blr
+	mfdcr  r3,147; blr
+	mtdcr  147,r4; blr
+	mfdcr  r3,148; blr
+	mtdcr  148,r4; blr
+	mfdcr  r3,149; blr
+	mtdcr  149,r4; blr
+	mfdcr  r3,150; blr
+	mtdcr  150,r4; blr
+	mfdcr  r3,151; blr
+	mtdcr  151,r4; blr
+	mfdcr  r3,152; blr
+	mtdcr  152,r4; blr
+	mfdcr  r3,153; blr
+	mtdcr  153,r4; blr
+	mfdcr  r3,154; blr
+	mtdcr  154,r4; blr
+	mfdcr  r3,155; blr
+	mtdcr  155,r4; blr
+	mfdcr  r3,156; blr
+	mtdcr  156,r4; blr
+	mfdcr  r3,157; blr
+	mtdcr  157,r4; blr
+	mfdcr  r3,158; blr
+	mtdcr  158,r4; blr
+	mfdcr  r3,159; blr
+	mtdcr  159,r4; blr
+	mfdcr  r3,160; blr
+	mtdcr  160,r4; blr
+	mfdcr  r3,161; blr
+	mtdcr  161,r4; blr
+	mfdcr  r3,162; blr
+	mtdcr  162,r4; blr
+	mfdcr  r3,163; blr
+	mtdcr  163,r4; blr
+	mfdcr  r3,164; blr
+	mtdcr  164,r4; blr
+	mfdcr  r3,165; blr
+	mtdcr  165,r4; blr
+	mfdcr  r3,166; blr
+	mtdcr  166,r4; blr
+	mfdcr  r3,167; blr
+	mtdcr  167,r4; blr
+	mfdcr  r3,168; blr
+	mtdcr  168,r4; blr
+	mfdcr  r3,169; blr
+	mtdcr  169,r4; blr
+	mfdcr  r3,170; blr
+	mtdcr  170,r4; blr
+	mfdcr  r3,171; blr
+	mtdcr  171,r4; blr
+	mfdcr  r3,172; blr
+	mtdcr  172,r4; blr
+	mfdcr  r3,173; blr
+	mtdcr  173,r4; blr
+	mfdcr  r3,174; blr
+	mtdcr  174,r4; blr
+	mfdcr  r3,175; blr
+	mtdcr  175,r4; blr
+	mfdcr  r3,176; blr
+	mtdcr  176,r4; blr
+	mfdcr  r3,177; blr
+	mtdcr  177,r4; blr
+	mfdcr  r3,178; blr
+	mtdcr  178,r4; blr
+	mfdcr  r3,179; blr
+	mtdcr  179,r4; blr
+	mfdcr  r3,180; blr
+	mtdcr  180,r4; blr
+	mfdcr  r3,181; blr
+	mtdcr  181,r4; blr
+	mfdcr  r3,182; blr
+	mtdcr  182,r4; blr
+	mfdcr  r3,183; blr
+	mtdcr  183,r4; blr
+	mfdcr  r3,184; blr
+	mtdcr  184,r4; blr
+	mfdcr  r3,185; blr
+	mtdcr  185,r4; blr
+	mfdcr  r3,186; blr
+	mtdcr  186,r4; blr
+	mfdcr  r3,187; blr
+	mtdcr  187,r4; blr
+	mfdcr  r3,188; blr
+	mtdcr  188,r4; blr
+	mfdcr  r3,189; blr
+	mtdcr  189,r4; blr
+	mfdcr  r3,190; blr
+	mtdcr  190,r4; blr
+	mfdcr  r3,191; blr
+	mtdcr  191,r4; blr
+	mfdcr  r3,192; blr
+	mtdcr  192,r4; blr
+	mfdcr  r3,193; blr
+	mtdcr  193,r4; blr
+	mfdcr  r3,194; blr
+	mtdcr  194,r4; blr
+	mfdcr  r3,195; blr
+	mtdcr  195,r4; blr
+	mfdcr  r3,196; blr
+	mtdcr  196,r4; blr
+	mfdcr  r3,197; blr
+	mtdcr  197,r4; blr
+	mfdcr  r3,198; blr
+	mtdcr  198,r4; blr
+	mfdcr  r3,199; blr
+	mtdcr  199,r4; blr
+	mfdcr  r3,200; blr
+	mtdcr  200,r4; blr
+	mfdcr  r3,201; blr
+	mtdcr  201,r4; blr
+	mfdcr  r3,202; blr
+	mtdcr  202,r4; blr
+	mfdcr  r3,203; blr
+	mtdcr  203,r4; blr
+	mfdcr  r3,204; blr
+	mtdcr  204,r4; blr
+	mfdcr  r3,205; blr
+	mtdcr  205,r4; blr
+	mfdcr  r3,206; blr
+	mtdcr  206,r4; blr
+	mfdcr  r3,207; blr
+	mtdcr  207,r4; blr
+	mfdcr  r3,208; blr
+	mtdcr  208,r4; blr
+	mfdcr  r3,209; blr
+	mtdcr  209,r4; blr
+	mfdcr  r3,210; blr
+	mtdcr  210,r4; blr
+	mfdcr  r3,211; blr
+	mtdcr  211,r4; blr
+	mfdcr  r3,212; blr
+	mtdcr  212,r4; blr
+	mfdcr  r3,213; blr
+	mtdcr  213,r4; blr
+	mfdcr  r3,214; blr
+	mtdcr  214,r4; blr
+	mfdcr  r3,215; blr
+	mtdcr  215,r4; blr
+	mfdcr  r3,216; blr
+	mtdcr  216,r4; blr
+	mfdcr  r3,217; blr
+	mtdcr  217,r4; blr
+	mfdcr  r3,218; blr
+	mtdcr  218,r4; blr
+	mfdcr  r3,219; blr
+	mtdcr  219,r4; blr
+	mfdcr  r3,220; blr
+	mtdcr  220,r4; blr
+	mfdcr  r3,221; blr
+	mtdcr  221,r4; blr
+	mfdcr  r3,222; blr
+	mtdcr  222,r4; blr
+	mfdcr  r3,223; blr
+	mtdcr  223,r4; blr
+	mfdcr  r3,224; blr
+	mtdcr  224,r4; blr
+	mfdcr  r3,225; blr
+	mtdcr  225,r4; blr
+	mfdcr  r3,226; blr
+	mtdcr  226,r4; blr
+	mfdcr  r3,227; blr
+	mtdcr  227,r4; blr
+	mfdcr  r3,228; blr
+	mtdcr  228,r4; blr
+	mfdcr  r3,229; blr
+	mtdcr  229,r4; blr
+	mfdcr  r3,230; blr
+	mtdcr  230,r4; blr
+	mfdcr  r3,231; blr
+	mtdcr  231,r4; blr
+	mfdcr  r3,232; blr
+	mtdcr  232,r4; blr
+	mfdcr  r3,233; blr
+	mtdcr  233,r4; blr
+	mfdcr  r3,234; blr
+	mtdcr  234,r4; blr
+	mfdcr  r3,235; blr
+	mtdcr  235,r4; blr
+	mfdcr  r3,236; blr
+	mtdcr  236,r4; blr
+	mfdcr  r3,237; blr
+	mtdcr  237,r4; blr
+	mfdcr  r3,238; blr
+	mtdcr  238,r4; blr
+	mfdcr  r3,239; blr
+	mtdcr  239,r4; blr
+	mfdcr  r3,240; blr
+	mtdcr  240,r4; blr
+	mfdcr  r3,241; blr
+	mtdcr  241,r4; blr
+	mfdcr  r3,242; blr
+	mtdcr  242,r4; blr
+	mfdcr  r3,243; blr
+	mtdcr  243,r4; blr
+	mfdcr  r3,244; blr
+	mtdcr  244,r4; blr
+	mfdcr  r3,245; blr
+	mtdcr  245,r4; blr
+	mfdcr  r3,246; blr
+	mtdcr  246,r4; blr
+	mfdcr  r3,247; blr
+	mtdcr  247,r4; blr
+	mfdcr  r3,248; blr
+	mtdcr  248,r4; blr
+	mfdcr  r3,249; blr
+	mtdcr  249,r4; blr
+	mfdcr  r3,250; blr
+	mtdcr  250,r4; blr
+	mfdcr  r3,251; blr
+	mtdcr  251,r4; blr
+	mfdcr  r3,252; blr
+	mtdcr  252,r4; blr
+	mfdcr  r3,253; blr
+	mtdcr  253,r4; blr
+	mfdcr  r3,254; blr
+	mtdcr  254,r4; blr
+	mfdcr  r3,255; blr
+	mtdcr  255,r4; blr
+	mfdcr  r3,256; blr
+	mtdcr  256,r4; blr
+	mfdcr  r3,257; blr
+	mtdcr  257,r4; blr
+	mfdcr  r3,258; blr
+	mtdcr  258,r4; blr
+	mfdcr  r3,259; blr
+	mtdcr  259,r4; blr
+	mfdcr  r3,260; blr
+	mtdcr  260,r4; blr
+	mfdcr  r3,261; blr
+	mtdcr  261,r4; blr
+	mfdcr  r3,262; blr
+	mtdcr  262,r4; blr
+	mfdcr  r3,263; blr
+	mtdcr  263,r4; blr
+	mfdcr  r3,264; blr
+	mtdcr  264,r4; blr
+	mfdcr  r3,265; blr
+	mtdcr  265,r4; blr
+	mfdcr  r3,266; blr
+	mtdcr  266,r4; blr
+	mfdcr  r3,267; blr
+	mtdcr  267,r4; blr
+	mfdcr  r3,268; blr
+	mtdcr  268,r4; blr
+	mfdcr  r3,269; blr
+	mtdcr  269,r4; blr
+	mfdcr  r3,270; blr
+	mtdcr  270,r4; blr
+	mfdcr  r3,271; blr
+	mtdcr  271,r4; blr
+	mfdcr  r3,272; blr
+	mtdcr  272,r4; blr
+	mfdcr  r3,273; blr
+	mtdcr  273,r4; blr
+	mfdcr  r3,274; blr
+	mtdcr  274,r4; blr
+	mfdcr  r3,275; blr
+	mtdcr  275,r4; blr
+	mfdcr  r3,276; blr
+	mtdcr  276,r4; blr
+	mfdcr  r3,277; blr
+	mtdcr  277,r4; blr
+	mfdcr  r3,278; blr
+	mtdcr  278,r4; blr
+	mfdcr  r3,279; blr
+	mtdcr  279,r4; blr
+	mfdcr  r3,280; blr
+	mtdcr  280,r4; blr
+	mfdcr  r3,281; blr
+	mtdcr  281,r4; blr
+	mfdcr  r3,282; blr
+	mtdcr  282,r4; blr
+	mfdcr  r3,283; blr
+	mtdcr  283,r4; blr
+	mfdcr  r3,284; blr
+	mtdcr  284,r4; blr
+	mfdcr  r3,285; blr
+	mtdcr  285,r4; blr
+	mfdcr  r3,286; blr
+	mtdcr  286,r4; blr
+	mfdcr  r3,287; blr
+	mtdcr  287,r4; blr
+	mfdcr  r3,288; blr
+	mtdcr  288,r4; blr
+	mfdcr  r3,289; blr
+	mtdcr  289,r4; blr
+	mfdcr  r3,290; blr
+	mtdcr  290,r4; blr
+	mfdcr  r3,291; blr
+	mtdcr  291,r4; blr
+	mfdcr  r3,292; blr
+	mtdcr  292,r4; blr
+	mfdcr  r3,293; blr
+	mtdcr  293,r4; blr
+	mfdcr  r3,294; blr
+	mtdcr  294,r4; blr
+	mfdcr  r3,295; blr
+	mtdcr  295,r4; blr
+	mfdcr  r3,296; blr
+	mtdcr  296,r4; blr
+	mfdcr  r3,297; blr
+	mtdcr  297,r4; blr
+	mfdcr  r3,298; blr
+	mtdcr  298,r4; blr
+	mfdcr  r3,299; blr
+	mtdcr  299,r4; blr
+	mfdcr  r3,300; blr
+	mtdcr  300,r4; blr
+	mfdcr  r3,301; blr
+	mtdcr  301,r4; blr
+	mfdcr  r3,302; blr
+	mtdcr  302,r4; blr
+	mfdcr  r3,303; blr
+	mtdcr  303,r4; blr
+	mfdcr  r3,304; blr
+	mtdcr  304,r4; blr
+	mfdcr  r3,305; blr
+	mtdcr  305,r4; blr
+	mfdcr  r3,306; blr
+	mtdcr  306,r4; blr
+	mfdcr  r3,307; blr
+	mtdcr  307,r4; blr
+	mfdcr  r3,308; blr
+	mtdcr  308,r4; blr
+	mfdcr  r3,309; blr
+	mtdcr  309,r4; blr
+	mfdcr  r3,310; blr
+	mtdcr  310,r4; blr
+	mfdcr  r3,311; blr
+	mtdcr  311,r4; blr
+	mfdcr  r3,312; blr
+	mtdcr  312,r4; blr
+	mfdcr  r3,313; blr
+	mtdcr  313,r4; blr
+	mfdcr  r3,314; blr
+	mtdcr  314,r4; blr
+	mfdcr  r3,315; blr
+	mtdcr  315,r4; blr
+	mfdcr  r3,316; blr
+	mtdcr  316,r4; blr
+	mfdcr  r3,317; blr
+	mtdcr  317,r4; blr
+	mfdcr  r3,318; blr
+	mtdcr  318,r4; blr
+	mfdcr  r3,319; blr
+	mtdcr  319,r4; blr
+	mfdcr  r3,320; blr
+	mtdcr  320,r4; blr
+	mfdcr  r3,321; blr
+	mtdcr  321,r4; blr
+	mfdcr  r3,322; blr
+	mtdcr  322,r4; blr
+	mfdcr  r3,323; blr
+	mtdcr  323,r4; blr
+	mfdcr  r3,324; blr
+	mtdcr  324,r4; blr
+	mfdcr  r3,325; blr
+	mtdcr  325,r4; blr
+	mfdcr  r3,326; blr
+	mtdcr  326,r4; blr
+	mfdcr  r3,327; blr
+	mtdcr  327,r4; blr
+	mfdcr  r3,328; blr
+	mtdcr  328,r4; blr
+	mfdcr  r3,329; blr
+	mtdcr  329,r4; blr
+	mfdcr  r3,330; blr
+	mtdcr  330,r4; blr
+	mfdcr  r3,331; blr
+	mtdcr  331,r4; blr
+	mfdcr  r3,332; blr
+	mtdcr  332,r4; blr
+	mfdcr  r3,333; blr
+	mtdcr  333,r4; blr
+	mfdcr  r3,334; blr
+	mtdcr  334,r4; blr
+	mfdcr  r3,335; blr
+	mtdcr  335,r4; blr
+	mfdcr  r3,336; blr
+	mtdcr  336,r4; blr
+	mfdcr  r3,337; blr
+	mtdcr  337,r4; blr
+	mfdcr  r3,338; blr
+	mtdcr  338,r4; blr
+	mfdcr  r3,339; blr
+	mtdcr  339,r4; blr
+	mfdcr  r3,340; blr
+	mtdcr  340,r4; blr
+	mfdcr  r3,341; blr
+	mtdcr  341,r4; blr
+	mfdcr  r3,342; blr
+	mtdcr  342,r4; blr
+	mfdcr  r3,343; blr
+	mtdcr  343,r4; blr
+	mfdcr  r3,344; blr
+	mtdcr  344,r4; blr
+	mfdcr  r3,345; blr
+	mtdcr  345,r4; blr
+	mfdcr  r3,346; blr
+	mtdcr  346,r4; blr
+	mfdcr  r3,347; blr
+	mtdcr  347,r4; blr
+	mfdcr  r3,348; blr
+	mtdcr  348,r4; blr
+	mfdcr  r3,349; blr
+	mtdcr  349,r4; blr
+	mfdcr  r3,350; blr
+	mtdcr  350,r4; blr
+	mfdcr  r3,351; blr
+	mtdcr  351,r4; blr
+	mfdcr  r3,352; blr
+	mtdcr  352,r4; blr
+	mfdcr  r3,353; blr
+	mtdcr  353,r4; blr
+	mfdcr  r3,354; blr
+	mtdcr  354,r4; blr
+	mfdcr  r3,355; blr
+	mtdcr  355,r4; blr
+	mfdcr  r3,356; blr
+	mtdcr  356,r4; blr
+	mfdcr  r3,357; blr
+	mtdcr  357,r4; blr
+	mfdcr  r3,358; blr
+	mtdcr  358,r4; blr
+	mfdcr  r3,359; blr
+	mtdcr  359,r4; blr
+	mfdcr  r3,360; blr
+	mtdcr  360,r4; blr
+	mfdcr  r3,361; blr
+	mtdcr  361,r4; blr
+	mfdcr  r3,362; blr
+	mtdcr  362,r4; blr
+	mfdcr  r3,363; blr
+	mtdcr  363,r4; blr
+	mfdcr  r3,364; blr
+	mtdcr  364,r4; blr
+	mfdcr  r3,365; blr
+	mtdcr  365,r4; blr
+	mfdcr  r3,366; blr
+	mtdcr  366,r4; blr
+	mfdcr  r3,367; blr
+	mtdcr  367,r4; blr
+	mfdcr  r3,368; blr
+	mtdcr  368,r4; blr
+	mfdcr  r3,369; blr
+	mtdcr  369,r4; blr
+	mfdcr  r3,370; blr
+	mtdcr  370,r4; blr
+	mfdcr  r3,371; blr
+	mtdcr  371,r4; blr
+	mfdcr  r3,372; blr
+	mtdcr  372,r4; blr
+	mfdcr  r3,373; blr
+	mtdcr  373,r4; blr
+	mfdcr  r3,374; blr
+	mtdcr  374,r4; blr
+	mfdcr  r3,375; blr
+	mtdcr  375,r4; blr
+	mfdcr  r3,376; blr
+	mtdcr  376,r4; blr
+	mfdcr  r3,377; blr
+	mtdcr  377,r4; blr
+	mfdcr  r3,378; blr
+	mtdcr  378,r4; blr
+	mfdcr  r3,379; blr
+	mtdcr  379,r4; blr
+	mfdcr  r3,380; blr
+	mtdcr  380,r4; blr
+	mfdcr  r3,381; blr
+	mtdcr  381,r4; blr
+	mfdcr  r3,382; blr
+	mtdcr  382,r4; blr
+	mfdcr  r3,383; blr
+	mtdcr  383,r4; blr
+	mfdcr  r3,384; blr
+	mtdcr  384,r4; blr
+	mfdcr  r3,385; blr
+	mtdcr  385,r4; blr
+	mfdcr  r3,386; blr
+	mtdcr  386,r4; blr
+	mfdcr  r3,387; blr
+	mtdcr  387,r4; blr
+	mfdcr  r3,388; blr
+	mtdcr  388,r4; blr
+	mfdcr  r3,389; blr
+	mtdcr  389,r4; blr
+	mfdcr  r3,390; blr
+	mtdcr  390,r4; blr
+	mfdcr  r3,391; blr
+	mtdcr  391,r4; blr
+	mfdcr  r3,392; blr
+	mtdcr  392,r4; blr
+	mfdcr  r3,393; blr
+	mtdcr  393,r4; blr
+	mfdcr  r3,394; blr
+	mtdcr  394,r4; blr
+	mfdcr  r3,395; blr
+	mtdcr  395,r4; blr
+	mfdcr  r3,396; blr
+	mtdcr  396,r4; blr
+	mfdcr  r3,397; blr
+	mtdcr  397,r4; blr
+	mfdcr  r3,398; blr
+	mtdcr  398,r4; blr
+	mfdcr  r3,399; blr
+	mtdcr  399,r4; blr
+	mfdcr  r3,400; blr
+	mtdcr  400,r4; blr
+	mfdcr  r3,401; blr
+	mtdcr  401,r4; blr
+	mfdcr  r3,402; blr
+	mtdcr  402,r4; blr
+	mfdcr  r3,403; blr
+	mtdcr  403,r4; blr
+	mfdcr  r3,404; blr
+	mtdcr  404,r4; blr
+	mfdcr  r3,405; blr
+	mtdcr  405,r4; blr
+	mfdcr  r3,406; blr
+	mtdcr  406,r4; blr
+	mfdcr  r3,407; blr
+	mtdcr  407,r4; blr
+	mfdcr  r3,408; blr
+	mtdcr  408,r4; blr
+	mfdcr  r3,409; blr
+	mtdcr  409,r4; blr
+	mfdcr  r3,410; blr
+	mtdcr  410,r4; blr
+	mfdcr  r3,411; blr
+	mtdcr  411,r4; blr
+	mfdcr  r3,412; blr
+	mtdcr  412,r4; blr
+	mfdcr  r3,413; blr
+	mtdcr  413,r4; blr
+	mfdcr  r3,414; blr
+	mtdcr  414,r4; blr
+	mfdcr  r3,415; blr
+	mtdcr  415,r4; blr
+	mfdcr  r3,416; blr
+	mtdcr  416,r4; blr
+	mfdcr  r3,417; blr
+	mtdcr  417,r4; blr
+	mfdcr  r3,418; blr
+	mtdcr  418,r4; blr
+	mfdcr  r3,419; blr
+	mtdcr  419,r4; blr
+	mfdcr  r3,420; blr
+	mtdcr  420,r4; blr
+	mfdcr  r3,421; blr
+	mtdcr  421,r4; blr
+	mfdcr  r3,422; blr
+	mtdcr  422,r4; blr
+	mfdcr  r3,423; blr
+	mtdcr  423,r4; blr
+	mfdcr  r3,424; blr
+	mtdcr  424,r4; blr
+	mfdcr  r3,425; blr
+	mtdcr  425,r4; blr
+	mfdcr  r3,426; blr
+	mtdcr  426,r4; blr
+	mfdcr  r3,427; blr
+	mtdcr  427,r4; blr
+	mfdcr  r3,428; blr
+	mtdcr  428,r4; blr
+	mfdcr  r3,429; blr
+	mtdcr  429,r4; blr
+	mfdcr  r3,430; blr
+	mtdcr  430,r4; blr
+	mfdcr  r3,431; blr
+	mtdcr  431,r4; blr
+	mfdcr  r3,432; blr
+	mtdcr  432,r4; blr
+	mfdcr  r3,433; blr
+	mtdcr  433,r4; blr
+	mfdcr  r3,434; blr
+	mtdcr  434,r4; blr
+	mfdcr  r3,435; blr
+	mtdcr  435,r4; blr
+	mfdcr  r3,436; blr
+	mtdcr  436,r4; blr
+	mfdcr  r3,437; blr
+	mtdcr  437,r4; blr
+	mfdcr  r3,438; blr
+	mtdcr  438,r4; blr
+	mfdcr  r3,439; blr
+	mtdcr  439,r4; blr
+	mfdcr  r3,440; blr
+	mtdcr  440,r4; blr
+	mfdcr  r3,441; blr
+	mtdcr  441,r4; blr
+	mfdcr  r3,442; blr
+	mtdcr  442,r4; blr
+	mfdcr  r3,443; blr
+	mtdcr  443,r4; blr
+	mfdcr  r3,444; blr
+	mtdcr  444,r4; blr
+	mfdcr  r3,445; blr
+	mtdcr  445,r4; blr
+	mfdcr  r3,446; blr
+	mtdcr  446,r4; blr
+	mfdcr  r3,447; blr
+	mtdcr  447,r4; blr
+	mfdcr  r3,448; blr
+	mtdcr  448,r4; blr
+	mfdcr  r3,449; blr
+	mtdcr  449,r4; blr
+	mfdcr  r3,450; blr
+	mtdcr  450,r4; blr
+	mfdcr  r3,451; blr
+	mtdcr  451,r4; blr
+	mfdcr  r3,452; blr
+	mtdcr  452,r4; blr
+	mfdcr  r3,453; blr
+	mtdcr  453,r4; blr
+	mfdcr  r3,454; blr
+	mtdcr  454,r4; blr
+	mfdcr  r3,455; blr
+	mtdcr  455,r4; blr
+	mfdcr  r3,456; blr
+	mtdcr  456,r4; blr
+	mfdcr  r3,457; blr
+	mtdcr  457,r4; blr
+	mfdcr  r3,458; blr
+	mtdcr  458,r4; blr
+	mfdcr  r3,459; blr
+	mtdcr  459,r4; blr
+	mfdcr  r3,460; blr
+	mtdcr  460,r4; blr
+	mfdcr  r3,461; blr
+	mtdcr  461,r4; blr
+	mfdcr  r3,462; blr
+	mtdcr  462,r4; blr
+	mfdcr  r3,463; blr
+	mtdcr  463,r4; blr
+	mfdcr  r3,464; blr
+	mtdcr  464,r4; blr
+	mfdcr  r3,465; blr
+	mtdcr  465,r4; blr
+	mfdcr  r3,466; blr
+	mtdcr  466,r4; blr
+	mfdcr  r3,467; blr
+	mtdcr  467,r4; blr
+	mfdcr  r3,468; blr
+	mtdcr  468,r4; blr
+	mfdcr  r3,469; blr
+	mtdcr  469,r4; blr
+	mfdcr  r3,470; blr
+	mtdcr  470,r4; blr
+	mfdcr  r3,471; blr
+	mtdcr  471,r4; blr
+	mfdcr  r3,472; blr
+	mtdcr  472,r4; blr
+	mfdcr  r3,473; blr
+	mtdcr  473,r4; blr
+	mfdcr  r3,474; blr
+	mtdcr  474,r4; blr
+	mfdcr  r3,475; blr
+	mtdcr  475,r4; blr
+	mfdcr  r3,476; blr
+	mtdcr  476,r4; blr
+	mfdcr  r3,477; blr
+	mtdcr  477,r4; blr
+	mfdcr  r3,478; blr
+	mtdcr  478,r4; blr
+	mfdcr  r3,479; blr
+	mtdcr  479,r4; blr
+	mfdcr  r3,480; blr
+	mtdcr  480,r4; blr
+	mfdcr  r3,481; blr
+	mtdcr  481,r4; blr
+	mfdcr  r3,482; blr
+	mtdcr  482,r4; blr
+	mfdcr  r3,483; blr
+	mtdcr  483,r4; blr
+	mfdcr  r3,484; blr
+	mtdcr  484,r4; blr
+	mfdcr  r3,485; blr
+	mtdcr  485,r4; blr
+	mfdcr  r3,486; blr
+	mtdcr  486,r4; blr
+	mfdcr  r3,487; blr
+	mtdcr  487,r4; blr
+	mfdcr  r3,488; blr
+	mtdcr  488,r4; blr
+	mfdcr  r3,489; blr
+	mtdcr  489,r4; blr
+	mfdcr  r3,490; blr
+	mtdcr  490,r4; blr
+	mfdcr  r3,491; blr
+	mtdcr  491,r4; blr
+	mfdcr  r3,492; blr
+	mtdcr  492,r4; blr
+	mfdcr  r3,493; blr
+	mtdcr  493,r4; blr
+	mfdcr  r3,494; blr
+	mtdcr  494,r4; blr
+	mfdcr  r3,495; blr
+	mtdcr  495,r4; blr
+	mfdcr  r3,496; blr
+	mtdcr  496,r4; blr
+	mfdcr  r3,497; blr
+	mtdcr  497,r4; blr
+	mfdcr  r3,498; blr
+	mtdcr  498,r4; blr
+	mfdcr  r3,499; blr
+	mtdcr  499,r4; blr
+	mfdcr  r3,500; blr
+	mtdcr  500,r4; blr
+	mfdcr  r3,501; blr
+	mtdcr  501,r4; blr
+	mfdcr  r3,502; blr
+	mtdcr  502,r4; blr
+	mfdcr  r3,503; blr
+	mtdcr  503,r4; blr
+	mfdcr  r3,504; blr
+	mtdcr  504,r4; blr
+	mfdcr  r3,505; blr
+	mtdcr  505,r4; blr
+	mfdcr  r3,506; blr
+	mtdcr  506,r4; blr
+	mfdcr  r3,507; blr
+	mtdcr  507,r4; blr
+	mfdcr  r3,508; blr
+	mtdcr  508,r4; blr
+	mfdcr  r3,509; blr
+	mtdcr  509,r4; blr
+	mfdcr  r3,510; blr
+	mtdcr  510,r4; blr
+	mfdcr  r3,511; blr
+	mtdcr  511,r4; blr
+	mfdcr  r3,512; blr
+	mtdcr  512,r4; blr
+	mfdcr  r3,513; blr
+	mtdcr  513,r4; blr
+	mfdcr  r3,514; blr
+	mtdcr  514,r4; blr
+	mfdcr  r3,515; blr
+	mtdcr  515,r4; blr
+	mfdcr  r3,516; blr
+	mtdcr  516,r4; blr
+	mfdcr  r3,517; blr
+	mtdcr  517,r4; blr
+	mfdcr  r3,518; blr
+	mtdcr  518,r4; blr
+	mfdcr  r3,519; blr
+	mtdcr  519,r4; blr
+	mfdcr  r3,520; blr
+	mtdcr  520,r4; blr
+	mfdcr  r3,521; blr
+	mtdcr  521,r4; blr
+	mfdcr  r3,522; blr
+	mtdcr  522,r4; blr
+	mfdcr  r3,523; blr
+	mtdcr  523,r4; blr
+	mfdcr  r3,524; blr
+	mtdcr  524,r4; blr
+	mfdcr  r3,525; blr
+	mtdcr  525,r4; blr
+	mfdcr  r3,526; blr
+	mtdcr  526,r4; blr
+	mfdcr  r3,527; blr
+	mtdcr  527,r4; blr
+	mfdcr  r3,528; blr
+	mtdcr  528,r4; blr
+	mfdcr  r3,529; blr
+	mtdcr  529,r4; blr
+	mfdcr  r3,530; blr
+	mtdcr  530,r4; blr
+	mfdcr  r3,531; blr
+	mtdcr  531,r4; blr
+	mfdcr  r3,532; blr
+	mtdcr  532,r4; blr
+	mfdcr  r3,533; blr
+	mtdcr  533,r4; blr
+	mfdcr  r3,534; blr
+	mtdcr  534,r4; blr
+	mfdcr  r3,535; blr
+	mtdcr  535,r4; blr
+	mfdcr  r3,536; blr
+	mtdcr  536,r4; blr
+	mfdcr  r3,537; blr
+	mtdcr  537,r4; blr
+	mfdcr  r3,538; blr
+	mtdcr  538,r4; blr
+	mfdcr  r3,539; blr
+	mtdcr  539,r4; blr
+	mfdcr  r3,540; blr
+	mtdcr  540,r4; blr
+	mfdcr  r3,541; blr
+	mtdcr  541,r4; blr
+	mfdcr  r3,542; blr
+	mtdcr  542,r4; blr
+	mfdcr  r3,543; blr
+	mtdcr  543,r4; blr
+	mfdcr  r3,544; blr
+	mtdcr  544,r4; blr
+	mfdcr  r3,545; blr
+	mtdcr  545,r4; blr
+	mfdcr  r3,546; blr
+	mtdcr  546,r4; blr
+	mfdcr  r3,547; blr
+	mtdcr  547,r4; blr
+	mfdcr  r3,548; blr
+	mtdcr  548,r4; blr
+	mfdcr  r3,549; blr
+	mtdcr  549,r4; blr
+	mfdcr  r3,550; blr
+	mtdcr  550,r4; blr
+	mfdcr  r3,551; blr
+	mtdcr  551,r4; blr
+	mfdcr  r3,552; blr
+	mtdcr  552,r4; blr
+	mfdcr  r3,553; blr
+	mtdcr  553,r4; blr
+	mfdcr  r3,554; blr
+	mtdcr  554,r4; blr
+	mfdcr  r3,555; blr
+	mtdcr  555,r4; blr
+	mfdcr  r3,556; blr
+	mtdcr  556,r4; blr
+	mfdcr  r3,557; blr
+	mtdcr  557,r4; blr
+	mfdcr  r3,558; blr
+	mtdcr  558,r4; blr
+	mfdcr  r3,559; blr
+	mtdcr  559,r4; blr
+	mfdcr  r3,560; blr
+	mtdcr  560,r4; blr
+	mfdcr  r3,561; blr
+	mtdcr  561,r4; blr
+	mfdcr  r3,562; blr
+	mtdcr  562,r4; blr
+	mfdcr  r3,563; blr
+	mtdcr  563,r4; blr
+	mfdcr  r3,564; blr
+	mtdcr  564,r4; blr
+	mfdcr  r3,565; blr
+	mtdcr  565,r4; blr
+	mfdcr  r3,566; blr
+	mtdcr  566,r4; blr
+	mfdcr  r3,567; blr
+	mtdcr  567,r4; blr
+	mfdcr  r3,568; blr
+	mtdcr  568,r4; blr
+	mfdcr  r3,569; blr
+	mtdcr  569,r4; blr
+	mfdcr  r3,570; blr
+	mtdcr  570,r4; blr
+	mfdcr  r3,571; blr
+	mtdcr  571,r4; blr
+	mfdcr  r3,572; blr
+	mtdcr  572,r4; blr
+	mfdcr  r3,573; blr
+	mtdcr  573,r4; blr
+	mfdcr  r3,574; blr
+	mtdcr  574,r4; blr
+	mfdcr  r3,575; blr
+	mtdcr  575,r4; blr
+	mfdcr  r3,576; blr
+	mtdcr  576,r4; blr
+	mfdcr  r3,577; blr
+	mtdcr  577,r4; blr
+	mfdcr  r3,578; blr
+	mtdcr  578,r4; blr
+	mfdcr  r3,579; blr
+	mtdcr  579,r4; blr
+	mfdcr  r3,580; blr
+	mtdcr  580,r4; blr
+	mfdcr  r3,581; blr
+	mtdcr  581,r4; blr
+	mfdcr  r3,582; blr
+	mtdcr  582,r4; blr
+	mfdcr  r3,583; blr
+	mtdcr  583,r4; blr
+	mfdcr  r3,584; blr
+	mtdcr  584,r4; blr
+	mfdcr  r3,585; blr
+	mtdcr  585,r4; blr
+	mfdcr  r3,586; blr
+	mtdcr  586,r4; blr
+	mfdcr  r3,587; blr
+	mtdcr  587,r4; blr
+	mfdcr  r3,588; blr
+	mtdcr  588,r4; blr
+	mfdcr  r3,589; blr
+	mtdcr  589,r4; blr
+	mfdcr  r3,590; blr
+	mtdcr  590,r4; blr
+	mfdcr  r3,591; blr
+	mtdcr  591,r4; blr
+	mfdcr  r3,592; blr
+	mtdcr  592,r4; blr
+	mfdcr  r3,593; blr
+	mtdcr  593,r4; blr
+	mfdcr  r3,594; blr
+	mtdcr  594,r4; blr
+	mfdcr  r3,595; blr
+	mtdcr  595,r4; blr
+	mfdcr  r3,596; blr
+	mtdcr  596,r4; blr
+	mfdcr  r3,597; blr
+	mtdcr  597,r4; blr
+	mfdcr  r3,598; blr
+	mtdcr  598,r4; blr
+	mfdcr  r3,599; blr
+	mtdcr  599,r4; blr
+	mfdcr  r3,600; blr
+	mtdcr  600,r4; blr
+	mfdcr  r3,601; blr
+	mtdcr  601,r4; blr
+	mfdcr  r3,602; blr
+	mtdcr  602,r4; blr
+	mfdcr  r3,603; blr
+	mtdcr  603,r4; blr
+	mfdcr  r3,604; blr
+	mtdcr  604,r4; blr
+	mfdcr  r3,605; blr
+	mtdcr  605,r4; blr
+	mfdcr  r3,606; blr
+	mtdcr  606,r4; blr
+	mfdcr  r3,607; blr
+	mtdcr  607,r4; blr
+	mfdcr  r3,608; blr
+	mtdcr  608,r4; blr
+	mfdcr  r3,609; blr
+	mtdcr  609,r4; blr
+	mfdcr  r3,610; blr
+	mtdcr  610,r4; blr
+	mfdcr  r3,611; blr
+	mtdcr  611,r4; blr
+	mfdcr  r3,612; blr
+	mtdcr  612,r4; blr
+	mfdcr  r3,613; blr
+	mtdcr  613,r4; blr
+	mfdcr  r3,614; blr
+	mtdcr  614,r4; blr
+	mfdcr  r3,615; blr
+	mtdcr  615,r4; blr
+	mfdcr  r3,616; blr
+	mtdcr  616,r4; blr
+	mfdcr  r3,617; blr
+	mtdcr  617,r4; blr
+	mfdcr  r3,618; blr
+	mtdcr  618,r4; blr
+	mfdcr  r3,619; blr
+	mtdcr  619,r4; blr
+	mfdcr  r3,620; blr
+	mtdcr  620,r4; blr
+	mfdcr  r3,621; blr
+	mtdcr  621,r4; blr
+	mfdcr  r3,622; blr
+	mtdcr  622,r4; blr
+	mfdcr  r3,623; blr
+	mtdcr  623,r4; blr
+	mfdcr  r3,624; blr
+	mtdcr  624,r4; blr
+	mfdcr  r3,625; blr
+	mtdcr  625,r4; blr
+	mfdcr  r3,626; blr
+	mtdcr  626,r4; blr
+	mfdcr  r3,627; blr
+	mtdcr  627,r4; blr
+	mfdcr  r3,628; blr
+	mtdcr  628,r4; blr
+	mfdcr  r3,629; blr
+	mtdcr  629,r4; blr
+	mfdcr  r3,630; blr
+	mtdcr  630,r4; blr
+	mfdcr  r3,631; blr
+	mtdcr  631,r4; blr
+	mfdcr  r3,632; blr
+	mtdcr  632,r4; blr
+	mfdcr  r3,633; blr
+	mtdcr  633,r4; blr
+	mfdcr  r3,634; blr
+	mtdcr  634,r4; blr
+	mfdcr  r3,635; blr
+	mtdcr  635,r4; blr
+	mfdcr  r3,636; blr
+	mtdcr  636,r4; blr
+	mfdcr  r3,637; blr
+	mtdcr  637,r4; blr
+	mfdcr  r3,638; blr
+	mtdcr  638,r4; blr
+	mfdcr  r3,639; blr
+	mtdcr  639,r4; blr
+	mfdcr  r3,640; blr
+	mtdcr  640,r4; blr
+	mfdcr  r3,641; blr
+	mtdcr  641,r4; blr
+	mfdcr  r3,642; blr
+	mtdcr  642,r4; blr
+	mfdcr  r3,643; blr
+	mtdcr  643,r4; blr
+	mfdcr  r3,644; blr
+	mtdcr  644,r4; blr
+	mfdcr  r3,645; blr
+	mtdcr  645,r4; blr
+	mfdcr  r3,646; blr
+	mtdcr  646,r4; blr
+	mfdcr  r3,647; blr
+	mtdcr  647,r4; blr
+	mfdcr  r3,648; blr
+	mtdcr  648,r4; blr
+	mfdcr  r3,649; blr
+	mtdcr  649,r4; blr
+	mfdcr  r3,650; blr
+	mtdcr  650,r4; blr
+	mfdcr  r3,651; blr
+	mtdcr  651,r4; blr
+	mfdcr  r3,652; blr
+	mtdcr  652,r4; blr
+	mfdcr  r3,653; blr
+	mtdcr  653,r4; blr
+	mfdcr  r3,654; blr
+	mtdcr  654,r4; blr
+	mfdcr  r3,655; blr
+	mtdcr  655,r4; blr
+	mfdcr  r3,656; blr
+	mtdcr  656,r4; blr
+	mfdcr  r3,657; blr
+	mtdcr  657,r4; blr
+	mfdcr  r3,658; blr
+	mtdcr  658,r4; blr
+	mfdcr  r3,659; blr
+	mtdcr  659,r4; blr
+	mfdcr  r3,660; blr
+	mtdcr  660,r4; blr
+	mfdcr  r3,661; blr
+	mtdcr  661,r4; blr
+	mfdcr  r3,662; blr
+	mtdcr  662,r4; blr
+	mfdcr  r3,663; blr
+	mtdcr  663,r4; blr
+	mfdcr  r3,664; blr
+	mtdcr  664,r4; blr
+	mfdcr  r3,665; blr
+	mtdcr  665,r4; blr
+	mfdcr  r3,666; blr
+	mtdcr  666,r4; blr
+	mfdcr  r3,667; blr
+	mtdcr  667,r4; blr
+	mfdcr  r3,668; blr
+	mtdcr  668,r4; blr
+	mfdcr  r3,669; blr
+	mtdcr  669,r4; blr
+	mfdcr  r3,670; blr
+	mtdcr  670,r4; blr
+	mfdcr  r3,671; blr
+	mtdcr  671,r4; blr
+	mfdcr  r3,672; blr
+	mtdcr  672,r4; blr
+	mfdcr  r3,673; blr
+	mtdcr  673,r4; blr
+	mfdcr  r3,674; blr
+	mtdcr  674,r4; blr
+	mfdcr  r3,675; blr
+	mtdcr  675,r4; blr
+	mfdcr  r3,676; blr
+	mtdcr  676,r4; blr
+	mfdcr  r3,677; blr
+	mtdcr  677,r4; blr
+	mfdcr  r3,678; blr
+	mtdcr  678,r4; blr
+	mfdcr  r3,679; blr
+	mtdcr  679,r4; blr
+	mfdcr  r3,680; blr
+	mtdcr  680,r4; blr
+	mfdcr  r3,681; blr
+	mtdcr  681,r4; blr
+	mfdcr  r3,682; blr
+	mtdcr  682,r4; blr
+	mfdcr  r3,683; blr
+	mtdcr  683,r4; blr
+	mfdcr  r3,684; blr
+	mtdcr  684,r4; blr
+	mfdcr  r3,685; blr
+	mtdcr  685,r4; blr
+	mfdcr  r3,686; blr
+	mtdcr  686,r4; blr
+	mfdcr  r3,687; blr
+	mtdcr  687,r4; blr
+	mfdcr  r3,688; blr
+	mtdcr  688,r4; blr
+	mfdcr  r3,689; blr
+	mtdcr  689,r4; blr
+	mfdcr  r3,690; blr
+	mtdcr  690,r4; blr
+	mfdcr  r3,691; blr
+	mtdcr  691,r4; blr
+	mfdcr  r3,692; blr
+	mtdcr  692,r4; blr
+	mfdcr  r3,693; blr
+	mtdcr  693,r4; blr
+	mfdcr  r3,694; blr
+	mtdcr  694,r4; blr
+	mfdcr  r3,695; blr
+	mtdcr  695,r4; blr
+	mfdcr  r3,696; blr
+	mtdcr  696,r4; blr
+	mfdcr  r3,697; blr
+	mtdcr  697,r4; blr
+	mfdcr  r3,698; blr
+	mtdcr  698,r4; blr
+	mfdcr  r3,699; blr
+	mtdcr  699,r4; blr
+	mfdcr  r3,700; blr
+	mtdcr  700,r4; blr
+	mfdcr  r3,701; blr
+	mtdcr  701,r4; blr
+	mfdcr  r3,702; blr
+	mtdcr  702,r4; blr
+	mfdcr  r3,703; blr
+	mtdcr  703,r4; blr
+	mfdcr  r3,704; blr
+	mtdcr  704,r4; blr
+	mfdcr  r3,705; blr
+	mtdcr  705,r4; blr
+	mfdcr  r3,706; blr
+	mtdcr  706,r4; blr
+	mfdcr  r3,707; blr
+	mtdcr  707,r4; blr
+	mfdcr  r3,708; blr
+	mtdcr  708,r4; blr
+	mfdcr  r3,709; blr
+	mtdcr  709,r4; blr
+	mfdcr  r3,710; blr
+	mtdcr  710,r4; blr
+	mfdcr  r3,711; blr
+	mtdcr  711,r4; blr
+	mfdcr  r3,712; blr
+	mtdcr  712,r4; blr
+	mfdcr  r3,713; blr
+	mtdcr  713,r4; blr
+	mfdcr  r3,714; blr
+	mtdcr  714,r4; blr
+	mfdcr  r3,715; blr
+	mtdcr  715,r4; blr
+	mfdcr  r3,716; blr
+	mtdcr  716,r4; blr
+	mfdcr  r3,717; blr
+	mtdcr  717,r4; blr
+	mfdcr  r3,718; blr
+	mtdcr  718,r4; blr
+	mfdcr  r3,719; blr
+	mtdcr  719,r4; blr
+	mfdcr  r3,720; blr
+	mtdcr  720,r4; blr
+	mfdcr  r3,721; blr
+	mtdcr  721,r4; blr
+	mfdcr  r3,722; blr
+	mtdcr  722,r4; blr
+	mfdcr  r3,723; blr
+	mtdcr  723,r4; blr
+	mfdcr  r3,724; blr
+	mtdcr  724,r4; blr
+	mfdcr  r3,725; blr
+	mtdcr  725,r4; blr
+	mfdcr  r3,726; blr
+	mtdcr  726,r4; blr
+	mfdcr  r3,727; blr
+	mtdcr  727,r4; blr
+	mfdcr  r3,728; blr
+	mtdcr  728,r4; blr
+	mfdcr  r3,729; blr
+	mtdcr  729,r4; blr
+	mfdcr  r3,730; blr
+	mtdcr  730,r4; blr
+	mfdcr  r3,731; blr
+	mtdcr  731,r4; blr
+	mfdcr  r3,732; blr
+	mtdcr  732,r4; blr
+	mfdcr  r3,733; blr
+	mtdcr  733,r4; blr
+	mfdcr  r3,734; blr
+	mtdcr  734,r4; blr
+	mfdcr  r3,735; blr
+	mtdcr  735,r4; blr
+	mfdcr  r3,736; blr
+	mtdcr  736,r4; blr
+	mfdcr  r3,737; blr
+	mtdcr  737,r4; blr
+	mfdcr  r3,738; blr
+	mtdcr  738,r4; blr
+	mfdcr  r3,739; blr
+	mtdcr  739,r4; blr
+	mfdcr  r3,740; blr
+	mtdcr  740,r4; blr
+	mfdcr  r3,741; blr
+	mtdcr  741,r4; blr
+	mfdcr  r3,742; blr
+	mtdcr  742,r4; blr
+	mfdcr  r3,743; blr
+	mtdcr  743,r4; blr
+	mfdcr  r3,744; blr
+	mtdcr  744,r4; blr
+	mfdcr  r3,745; blr
+	mtdcr  745,r4; blr
+	mfdcr  r3,746; blr
+	mtdcr  746,r4; blr
+	mfdcr  r3,747; blr
+	mtdcr  747,r4; blr
+	mfdcr  r3,748; blr
+	mtdcr  748,r4; blr
+	mfdcr  r3,749; blr
+	mtdcr  749,r4; blr
+	mfdcr  r3,750; blr
+	mtdcr  750,r4; blr
+	mfdcr  r3,751; blr
+	mtdcr  751,r4; blr
+	mfdcr  r3,752; blr
+	mtdcr  752,r4; blr
+	mfdcr  r3,753; blr
+	mtdcr  753,r4; blr
+	mfdcr  r3,754; blr
+	mtdcr  754,r4; blr
+	mfdcr  r3,755; blr
+	mtdcr  755,r4; blr
+	mfdcr  r3,756; blr
+	mtdcr  756,r4; blr
+	mfdcr  r3,757; blr
+	mtdcr  757,r4; blr
+	mfdcr  r3,758; blr
+	mtdcr  758,r4; blr
+	mfdcr  r3,759; blr
+	mtdcr  759,r4; blr
+	mfdcr  r3,760; blr
+	mtdcr  760,r4; blr
+	mfdcr  r3,761; blr
+	mtdcr  761,r4; blr
+	mfdcr  r3,762; blr
+	mtdcr  762,r4; blr
+	mfdcr  r3,763; blr
+	mtdcr  763,r4; blr
+	mfdcr  r3,764; blr
+	mtdcr  764,r4; blr
+	mfdcr  r3,765; blr
+	mtdcr  765,r4; blr
+	mfdcr  r3,766; blr
+	mtdcr  766,r4; blr
+	mfdcr  r3,767; blr
+	mtdcr  767,r4; blr
+	mfdcr  r3,768; blr
+	mtdcr  768,r4; blr
+	mfdcr  r3,769; blr
+	mtdcr  769,r4; blr
+	mfdcr  r3,770; blr
+	mtdcr  770,r4; blr
+	mfdcr  r3,771; blr
+	mtdcr  771,r4; blr
+	mfdcr  r3,772; blr
+	mtdcr  772,r4; blr
+	mfdcr  r3,773; blr
+	mtdcr  773,r4; blr
+	mfdcr  r3,774; blr
+	mtdcr  774,r4; blr
+	mfdcr  r3,775; blr
+	mtdcr  775,r4; blr
+	mfdcr  r3,776; blr
+	mtdcr  776,r4; blr
+	mfdcr  r3,777; blr
+	mtdcr  777,r4; blr
+	mfdcr  r3,778; blr
+	mtdcr  778,r4; blr
+	mfdcr  r3,779; blr
+	mtdcr  779,r4; blr
+	mfdcr  r3,780; blr
+	mtdcr  780,r4; blr
+	mfdcr  r3,781; blr
+	mtdcr  781,r4; blr
+	mfdcr  r3,782; blr
+	mtdcr  782,r4; blr
+	mfdcr  r3,783; blr
+	mtdcr  783,r4; blr
+	mfdcr  r3,784; blr
+	mtdcr  784,r4; blr
+	mfdcr  r3,785; blr
+	mtdcr  785,r4; blr
+	mfdcr  r3,786; blr
+	mtdcr  786,r4; blr
+	mfdcr  r3,787; blr
+	mtdcr  787,r4; blr
+	mfdcr  r3,788; blr
+	mtdcr  788,r4; blr
+	mfdcr  r3,789; blr
+	mtdcr  789,r4; blr
+	mfdcr  r3,790; blr
+	mtdcr  790,r4; blr
+	mfdcr  r3,791; blr
+	mtdcr  791,r4; blr
+	mfdcr  r3,792; blr
+	mtdcr  792,r4; blr
+	mfdcr  r3,793; blr
+	mtdcr  793,r4; blr
+	mfdcr  r3,794; blr
+	mtdcr  794,r4; blr
+	mfdcr  r3,795; blr
+	mtdcr  795,r4; blr
+	mfdcr  r3,796; blr
+	mtdcr  796,r4; blr
+	mfdcr  r3,797; blr
+	mtdcr  797,r4; blr
+	mfdcr  r3,798; blr
+	mtdcr  798,r4; blr
+	mfdcr  r3,799; blr
+	mtdcr  799,r4; blr
+	mfdcr  r3,800; blr
+	mtdcr  800,r4; blr
+	mfdcr  r3,801; blr
+	mtdcr  801,r4; blr
+	mfdcr  r3,802; blr
+	mtdcr  802,r4; blr
+	mfdcr  r3,803; blr
+	mtdcr  803,r4; blr
+	mfdcr  r3,804; blr
+	mtdcr  804,r4; blr
+	mfdcr  r3,805; blr
+	mtdcr  805,r4; blr
+	mfdcr  r3,806; blr
+	mtdcr  806,r4; blr
+	mfdcr  r3,807; blr
+	mtdcr  807,r4; blr
+	mfdcr  r3,808; blr
+	mtdcr  808,r4; blr
+	mfdcr  r3,809; blr
+	mtdcr  809,r4; blr
+	mfdcr  r3,810; blr
+	mtdcr  810,r4; blr
+	mfdcr  r3,811; blr
+	mtdcr  811,r4; blr
+	mfdcr  r3,812; blr
+	mtdcr  812,r4; blr
+	mfdcr  r3,813; blr
+	mtdcr  813,r4; blr
+	mfdcr  r3,814; blr
+	mtdcr  814,r4; blr
+	mfdcr  r3,815; blr
+	mtdcr  815,r4; blr
+	mfdcr  r3,816; blr
+	mtdcr  816,r4; blr
+	mfdcr  r3,817; blr
+	mtdcr  817,r4; blr
+	mfdcr  r3,818; blr
+	mtdcr  818,r4; blr
+	mfdcr  r3,819; blr
+	mtdcr  819,r4; blr
+	mfdcr  r3,820; blr
+	mtdcr  820,r4; blr
+	mfdcr  r3,821; blr
+	mtdcr  821,r4; blr
+	mfdcr  r3,822; blr
+	mtdcr  822,r4; blr
+	mfdcr  r3,823; blr
+	mtdcr  823,r4; blr
+	mfdcr  r3,824; blr
+	mtdcr  824,r4; blr
+	mfdcr  r3,825; blr
+	mtdcr  825,r4; blr
+	mfdcr  r3,826; blr
+	mtdcr  826,r4; blr
+	mfdcr  r3,827; blr
+	mtdcr  827,r4; blr
+	mfdcr  r3,828; blr
+	mtdcr  828,r4; blr
+	mfdcr  r3,829; blr
+	mtdcr  829,r4; blr
+	mfdcr  r3,830; blr
+	mtdcr  830,r4; blr
+	mfdcr  r3,831; blr
+	mtdcr  831,r4; blr
+	mfdcr  r3,832; blr
+	mtdcr  832,r4; blr
+	mfdcr  r3,833; blr
+	mtdcr  833,r4; blr
+	mfdcr  r3,834; blr
+	mtdcr  834,r4; blr
+	mfdcr  r3,835; blr
+	mtdcr  835,r4; blr
+	mfdcr  r3,836; blr
+	mtdcr  836,r4; blr
+	mfdcr  r3,837; blr
+	mtdcr  837,r4; blr
+	mfdcr  r3,838; blr
+	mtdcr  838,r4; blr
+	mfdcr  r3,839; blr
+	mtdcr  839,r4; blr
+	mfdcr  r3,840; blr
+	mtdcr  840,r4; blr
+	mfdcr  r3,841; blr
+	mtdcr  841,r4; blr
+	mfdcr  r3,842; blr
+	mtdcr  842,r4; blr
+	mfdcr  r3,843; blr
+	mtdcr  843,r4; blr
+	mfdcr  r3,844; blr
+	mtdcr  844,r4; blr
+	mfdcr  r3,845; blr
+	mtdcr  845,r4; blr
+	mfdcr  r3,846; blr
+	mtdcr  846,r4; blr
+	mfdcr  r3,847; blr
+	mtdcr  847,r4; blr
+	mfdcr  r3,848; blr
+	mtdcr  848,r4; blr
+	mfdcr  r3,849; blr
+	mtdcr  849,r4; blr
+	mfdcr  r3,850; blr
+	mtdcr  850,r4; blr
+	mfdcr  r3,851; blr
+	mtdcr  851,r4; blr
+	mfdcr  r3,852; blr
+	mtdcr  852,r4; blr
+	mfdcr  r3,853; blr
+	mtdcr  853,r4; blr
+	mfdcr  r3,854; blr
+	mtdcr  854,r4; blr
+	mfdcr  r3,855; blr
+	mtdcr  855,r4; blr
+	mfdcr  r3,856; blr
+	mtdcr  856,r4; blr
+	mfdcr  r3,857; blr
+	mtdcr  857,r4; blr
+	mfdcr  r3,858; blr
+	mtdcr  858,r4; blr
+	mfdcr  r3,859; blr
+	mtdcr  859,r4; blr
+	mfdcr  r3,860; blr
+	mtdcr  860,r4; blr
+	mfdcr  r3,861; blr
+	mtdcr  861,r4; blr
+	mfdcr  r3,862; blr
+	mtdcr  862,r4; blr
+	mfdcr  r3,863; blr
+	mtdcr  863,r4; blr
+	mfdcr  r3,864; blr
+	mtdcr  864,r4; blr
+	mfdcr  r3,865; blr
+	mtdcr  865,r4; blr
+	mfdcr  r3,866; blr
+	mtdcr  866,r4; blr
+	mfdcr  r3,867; blr
+	mtdcr  867,r4; blr
+	mfdcr  r3,868; blr
+	mtdcr  868,r4; blr
+	mfdcr  r3,869; blr
+	mtdcr  869,r4; blr
+	mfdcr  r3,870; blr
+	mtdcr  870,r4; blr
+	mfdcr  r3,871; blr
+	mtdcr  871,r4; blr
+	mfdcr  r3,872; blr
+	mtdcr  872,r4; blr
+	mfdcr  r3,873; blr
+	mtdcr  873,r4; blr
+	mfdcr  r3,874; blr
+	mtdcr  874,r4; blr
+	mfdcr  r3,875; blr
+	mtdcr  875,r4; blr
+	mfdcr  r3,876; blr
+	mtdcr  876,r4; blr
+	mfdcr  r3,877; blr
+	mtdcr  877,r4; blr
+	mfdcr  r3,878; blr
+	mtdcr  878,r4; blr
+	mfdcr  r3,879; blr
+	mtdcr  879,r4; blr
+	mfdcr  r3,880; blr
+	mtdcr  880,r4; blr
+	mfdcr  r3,881; blr
+	mtdcr  881,r4; blr
+	mfdcr  r3,882; blr
+	mtdcr  882,r4; blr
+	mfdcr  r3,883; blr
+	mtdcr  883,r4; blr
+	mfdcr  r3,884; blr
+	mtdcr  884,r4; blr
+	mfdcr  r3,885; blr
+	mtdcr  885,r4; blr
+	mfdcr  r3,886; blr
+	mtdcr  886,r4; blr
+	mfdcr  r3,887; blr
+	mtdcr  887,r4; blr
+	mfdcr  r3,888; blr
+	mtdcr  888,r4; blr
+	mfdcr  r3,889; blr
+	mtdcr  889,r4; blr
+	mfdcr  r3,890; blr
+	mtdcr  890,r4; blr
+	mfdcr  r3,891; blr
+	mtdcr  891,r4; blr
+	mfdcr  r3,892; blr
+	mtdcr  892,r4; blr
+	mfdcr  r3,893; blr
+	mtdcr  893,r4; blr
+	mfdcr  r3,894; blr
+	mtdcr  894,r4; blr
+	mfdcr  r3,895; blr
+	mtdcr  895,r4; blr
+	mfdcr  r3,896; blr
+	mtdcr  896,r4; blr
+	mfdcr  r3,897; blr
+	mtdcr  897,r4; blr
+	mfdcr  r3,898; blr
+	mtdcr  898,r4; blr
+	mfdcr  r3,899; blr
+	mtdcr  899,r4; blr
+	mfdcr  r3,900; blr
+	mtdcr  900,r4; blr
+	mfdcr  r3,901; blr
+	mtdcr  901,r4; blr
+	mfdcr  r3,902; blr
+	mtdcr  902,r4; blr
+	mfdcr  r3,903; blr
+	mtdcr  903,r4; blr
+	mfdcr  r3,904; blr
+	mtdcr  904,r4; blr
+	mfdcr  r3,905; blr
+	mtdcr  905,r4; blr
+	mfdcr  r3,906; blr
+	mtdcr  906,r4; blr
+	mfdcr  r3,907; blr
+	mtdcr  907,r4; blr
+	mfdcr  r3,908; blr
+	mtdcr  908,r4; blr
+	mfdcr  r3,909; blr
+	mtdcr  909,r4; blr
+	mfdcr  r3,910; blr
+	mtdcr  910,r4; blr
+	mfdcr  r3,911; blr
+	mtdcr  911,r4; blr
+	mfdcr  r3,912; blr
+	mtdcr  912,r4; blr
+	mfdcr  r3,913; blr
+	mtdcr  913,r4; blr
+	mfdcr  r3,914; blr
+	mtdcr  914,r4; blr
+	mfdcr  r3,915; blr
+	mtdcr  915,r4; blr
+	mfdcr  r3,916; blr
+	mtdcr  916,r4; blr
+	mfdcr  r3,917; blr
+	mtdcr  917,r4; blr
+	mfdcr  r3,918; blr
+	mtdcr  918,r4; blr
+	mfdcr  r3,919; blr
+	mtdcr  919,r4; blr
+	mfdcr  r3,920; blr
+	mtdcr  920,r4; blr
+	mfdcr  r3,921; blr
+	mtdcr  921,r4; blr
+	mfdcr  r3,922; blr
+	mtdcr  922,r4; blr
+	mfdcr  r3,923; blr
+	mtdcr  923,r4; blr
+	mfdcr  r3,924; blr
+	mtdcr  924,r4; blr
+	mfdcr  r3,925; blr
+	mtdcr  925,r4; blr
+	mfdcr  r3,926; blr
+	mtdcr  926,r4; blr
+	mfdcr  r3,927; blr
+	mtdcr  927,r4; blr
+	mfdcr  r3,928; blr
+	mtdcr  928,r4; blr
+	mfdcr  r3,929; blr
+	mtdcr  929,r4; blr
+	mfdcr  r3,930; blr
+	mtdcr  930,r4; blr
+	mfdcr  r3,931; blr
+	mtdcr  931,r4; blr
+	mfdcr  r3,932; blr
+	mtdcr  932,r4; blr
+	mfdcr  r3,933; blr
+	mtdcr  933,r4; blr
+	mfdcr  r3,934; blr
+	mtdcr  934,r4; blr
+	mfdcr  r3,935; blr
+	mtdcr  935,r4; blr
+	mfdcr  r3,936; blr
+	mtdcr  936,r4; blr
+	mfdcr  r3,937; blr
+	mtdcr  937,r4; blr
+	mfdcr  r3,938; blr
+	mtdcr  938,r4; blr
+	mfdcr  r3,939; blr
+	mtdcr  939,r4; blr
+	mfdcr  r3,940; blr
+	mtdcr  940,r4; blr
+	mfdcr  r3,941; blr
+	mtdcr  941,r4; blr
+	mfdcr  r3,942; blr
+	mtdcr  942,r4; blr
+	mfdcr  r3,943; blr
+	mtdcr  943,r4; blr
+	mfdcr  r3,944; blr
+	mtdcr  944,r4; blr
+	mfdcr  r3,945; blr
+	mtdcr  945,r4; blr
+	mfdcr  r3,946; blr
+	mtdcr  946,r4; blr
+	mfdcr  r3,947; blr
+	mtdcr  947,r4; blr
+	mfdcr  r3,948; blr
+	mtdcr  948,r4; blr
+	mfdcr  r3,949; blr
+	mtdcr  949,r4; blr
+	mfdcr  r3,950; blr
+	mtdcr  950,r4; blr
+	mfdcr  r3,951; blr
+	mtdcr  951,r4; blr
+	mfdcr  r3,952; blr
+	mtdcr  952,r4; blr
+	mfdcr  r3,953; blr
+	mtdcr  953,r4; blr
+	mfdcr  r3,954; blr
+	mtdcr  954,r4; blr
+	mfdcr  r3,955; blr
+	mtdcr  955,r4; blr
+	mfdcr  r3,956; blr
+	mtdcr  956,r4; blr
+	mfdcr  r3,957; blr
+	mtdcr  957,r4; blr
+	mfdcr  r3,958; blr
+	mtdcr  958,r4; blr
+	mfdcr  r3,959; blr
+	mtdcr  959,r4; blr
+	mfdcr  r3,960; blr
+	mtdcr  960,r4; blr
+	mfdcr  r3,961; blr
+	mtdcr  961,r4; blr
+	mfdcr  r3,962; blr
+	mtdcr  962,r4; blr
+	mfdcr  r3,963; blr
+	mtdcr  963,r4; blr
+	mfdcr  r3,964; blr
+	mtdcr  964,r4; blr
+	mfdcr  r3,965; blr
+	mtdcr  965,r4; blr
+	mfdcr  r3,966; blr
+	mtdcr  966,r4; blr
+	mfdcr  r3,967; blr
+	mtdcr  967,r4; blr
+	mfdcr  r3,968; blr
+	mtdcr  968,r4; blr
+	mfdcr  r3,969; blr
+	mtdcr  969,r4; blr
+	mfdcr  r3,970; blr
+	mtdcr  970,r4; blr
+	mfdcr  r3,971; blr
+	mtdcr  971,r4; blr
+	mfdcr  r3,972; blr
+	mtdcr  972,r4; blr
+	mfdcr  r3,973; blr
+	mtdcr  973,r4; blr
+	mfdcr  r3,974; blr
+	mtdcr  974,r4; blr
+	mfdcr  r3,975; blr
+	mtdcr  975,r4; blr
+	mfdcr  r3,976; blr
+	mtdcr  976,r4; blr
+	mfdcr  r3,977; blr
+	mtdcr  977,r4; blr
+	mfdcr  r3,978; blr
+	mtdcr  978,r4; blr
+	mfdcr  r3,979; blr
+	mtdcr  979,r4; blr
+	mfdcr  r3,980; blr
+	mtdcr  980,r4; blr
+	mfdcr  r3,981; blr
+	mtdcr  981,r4; blr
+	mfdcr  r3,982; blr
+	mtdcr  982,r4; blr
+	mfdcr  r3,983; blr
+	mtdcr  983,r4; blr
+	mfdcr  r3,984; blr
+	mtdcr  984,r4; blr
+	mfdcr  r3,985; blr
+	mtdcr  985,r4; blr
+	mfdcr  r3,986; blr
+	mtdcr  986,r4; blr
+	mfdcr  r3,987; blr
+	mtdcr  987,r4; blr
+	mfdcr  r3,988; blr
+	mtdcr  988,r4; blr
+	mfdcr  r3,989; blr
+	mtdcr  989,r4; blr
+	mfdcr  r3,990; blr
+	mtdcr  990,r4; blr
+	mfdcr  r3,991; blr
+	mtdcr  991,r4; blr
+	mfdcr  r3,992; blr
+	mtdcr  992,r4; blr
+	mfdcr  r3,993; blr
+	mtdcr  993,r4; blr
+	mfdcr  r3,994; blr
+	mtdcr  994,r4; blr
+	mfdcr  r3,995; blr
+	mtdcr  995,r4; blr
+	mfdcr  r3,996; blr
+	mtdcr  996,r4; blr
+	mfdcr  r3,997; blr
+	mtdcr  997,r4; blr
+	mfdcr  r3,998; blr
+	mtdcr  998,r4; blr
+	mfdcr  r3,999; blr
+	mtdcr  999,r4; blr
+	mfdcr  r3,1000; blr
+	mtdcr  1000,r4; blr
+	mfdcr  r3,1001; blr
+	mtdcr  1001,r4; blr
+	mfdcr  r3,1002; blr
+	mtdcr  1002,r4; blr
+	mfdcr  r3,1003; blr
+	mtdcr  1003,r4; blr
+	mfdcr  r3,1004; blr
+	mtdcr  1004,r4; blr
+	mfdcr  r3,1005; blr
+	mtdcr  1005,r4; blr
+	mfdcr  r3,1006; blr
+	mtdcr  1006,r4; blr
+	mfdcr  r3,1007; blr
+	mtdcr  1007,r4; blr
+	mfdcr  r3,1008; blr
+	mtdcr  1008,r4; blr
+	mfdcr  r3,1009; blr
+	mtdcr  1009,r4; blr
+	mfdcr  r3,1010; blr
+	mtdcr  1010,r4; blr
+	mfdcr  r3,1011; blr
+	mtdcr  1011,r4; blr
+	mfdcr  r3,1012; blr
+	mtdcr  1012,r4; blr
+	mfdcr  r3,1013; blr
+	mtdcr  1013,r4; blr
+	mfdcr  r3,1014; blr
+	mtdcr  1014,r4; blr
+	mfdcr  r3,1015; blr
+	mtdcr  1015,r4; blr
+	mfdcr  r3,1016; blr
+	mtdcr  1016,r4; blr
+	mfdcr  r3,1017; blr
+	mtdcr  1017,r4; blr
+	mfdcr  r3,1018; blr
+	mtdcr  1018,r4; blr
+	mfdcr  r3,1019; blr
+	mtdcr  1019,r4; blr
+	mfdcr  r3,1020; blr
+	mtdcr  1020,r4; blr
+	mfdcr  r3,1021; blr
+	mtdcr  1021,r4; blr
+	mfdcr  r3,1022; blr
+	mtdcr  1022,r4; blr
+	mfdcr  r3,1023; blr
+	mtdcr  1023,r4; blr
diff -Nru a/include/asm-ppc/reg_booke.h b/include/asm-ppc/reg_booke.h
--- a/include/asm-ppc/reg_booke.h	Thu Mar 11 16:54:04 2004
+++ b/include/asm-ppc/reg_booke.h	Thu Mar 11 16:54:04 2004
@@ -26,6 +26,9 @@
 		asm volatile("mtdcr " __stringify(rn) ",%0" : : "r" (v)); \
 } while (0)
 
+void __mtdcr(int reg, unsigned int val);
+unsigned int __mfdcr(int reg);
+
 /* R/W of indirect DCRs make use of standard naming conventions for DCRs */
 #define mfdcri(base, reg)			\
 ({						\
